from intersectionLib import *
def exchangeList(XX,i,j):    #■位置iの直後にjを挿入
    N=len(XX);R=array(N);kk=0
    for k in range(i+1):
        if k!=j:R[kk]=copyList(XX[k]);kk+=1
    R[kk]=copyList(XX[j]);kk+=1
    for k in range(i+1,N):
        if k!=j:R[kk]=copyList(XX[k]);kk+=1
    return R
def get2Point(XX,i,j):          #■2点取り出し
    N=len(XX); Xi=copyList(XX[i]);Xj=copyList(XX[j])
    ii=0;R=array(N-2)
    for k in range(N):
        if k!=i and k!=j:R[ii]=copyList(XX[k]);ii+=1
    return [Xi,Xj,R]
def set2Point(R,Xi,Xj,ki,kj):   #■2点設定
    N=len(R);Z=array(N+2);ii=0
    for k in range(N):
        if k==ki: Z[ii]=copyList(Xi);ii+=1
        if k==kj: Z[ii]=copyList(Xj);ii+=1
        Z[ii]=copyList(R[k]);ii+=1
    return Z
def replace2Point(XX,P1,P2,P3,P4):
    N=len(XX);R=[]
    for i in range(N):
        if XX[i][2]!=P3[2] and XX[i][2]!=P4[2]:
            R.append(copyList(XX[i]))
            if XX[i][2]==P1[2]:
                R.append(copyList(P3));R.append(copyList(P4))
    NN=len(R)#近場に交差する辺があるときを避ける
    if N!=NN:return XX
    return R
def inverseRoot(XX):
    N=len(XX); NH=int(N/2)
    for i in range(NH):
        T=XX[i];XX[i]=XX[N-i-1];XX[N-i-1]=T
    return XX
def lenVisit2(XX,k): #■k番目がないときの訪問巡回路長計算
    N=len(XX);NN=N-1;T=0;j=NN
    for i in range(N):
        if k!=i:
            T+=compR(XX[j][0],XX[j][1],XX[i][0],XX[i][1])
            j=i
    return T
def nearPoint(XX,P1,P2,CHMIN, CHAREA1):#■近傍の1点を取り出す
    N=len(XX);MN=1E30;ID=-1;R=[]
    R0=setDist(P1,P2)*CHAREA1
    if R0<CHMIN:R0=CHMIN #短いとき一定距離とする
    for i in range(N):
        if P1[2]!=XX[i][2] and P2[2]!=XX[i][2]:
            if setDist(P1,XX[i])<R0:
                DX=XX[i][0]-P1[0];DY=XX[i][1]-P1[1]
                D2=lenVisit2(XX,i)
                if D2<=MN: MN=D2;ID=i
    if ID<0: return []
    for i in range(N):
        if i!=ID:R.append(XX[i])
    return [XX[ID],R]
def insert2Point(XX,P1,P3,P4):#■P1の後にP3，P4を挿入
    N=len(XX);R=[]
    for i in range(N):
        R.append(XX[i])
        if P1[2]==XX[i][2]: R.append(P3);R.append(P4)
    return R

